
#include <stdio.h>
#include <stdlib.h>

typedef struct {
	int position;
	int direction;
} ant_t;

enum {
	LEFT,
	RIGHT
};

int cmp(const void *v1, const void *v2) {
	ant_t *a1 = (ant_t*) v1;
	ant_t *a2 = (ant_t*) v2;
	return (a1->position - a2->position);
}

#define maximize(name, val) \
	{ if ((val) > name) name = (val); }

int main(void) {
	int i;
	int L, A;
	
	while(scanf(" %d %d", &L, &A) == 2) {
		ant_t ant;
		char c;
		
		ant_t *ants = (ant_t*)malloc(sizeof(ant_t) * A);
		for (i = 0; i < A; i++) {
			scanf(" %d %c", &ant.position, &c);
			ant.direction = (c == 'R') ? RIGHT : LEFT;
			
			ants[i] = ant;
		}

		qsort(ants, A, sizeof(ant_t), cmp);
		
		int lefts = 0;
		int rights = 0;
		
		int max_right = -1;
		int max_left = -1;
		
		for (int i = 0; i < A; i++) {
			ant = ants[i];
			
			if (ant.direction == RIGHT) {
				rights++;
			
				int len = L - ant.position;
				if (len > max_right) {
					max_right = len;
				}
			} else {
				lefts++;
			
				if (ant.position > max_left) {
					max_left = ant.position;
				}
			}
		}
		
		ant_t last_left;
		ant_t last_right;
		
		last_left.position = -1;
		last_right.position = -1;
		if (lefts != 0) {
			last_left = ants[lefts-1];
		}
		if (rights != 0) {
			last_right = ants[lefts];
		}
		
		if (max_right == max_left) {
			if (last_left.position > last_right.position) {
				int tmp = last_left.position;
				last_left.position = last_right.position;
				last_right.position = tmp;
			}
			printf("The last ant will fall down in %d seconds - started at %d and %d.\n", max_right, last_left.position, last_right.position);
		} else if (max_right > max_left) {
			printf("The last ant will fall down in %d seconds - started at %d.\n", max_right, last_right.position);
		} else {
			printf("The last ant will fall down in %d seconds - started at %d.\n", max_left, last_left.position);
		}
	}
	
	return 0;
}
