
#include <stdio.h>

bool contains(int *hand, int card) {
	for (int i = 0; i < 7; i++) {
		if hand[i] == card {
			return true;
		}
	}
	return false;
}

bool same(int hand[5], int first, int last) {
	for (int i = first; i < last; i++) {
		if (hand[i] != hand[i+1]) {
			return false;
		}
	}
	return true;
}

int flush(int color[5]) {
	if (same(color, 0, 4)) {
		return FLUSH_MASK;
	}
	return 0;
}

int straight(int hand[5]) {
	if ((hand[2] == hand[1] + 1 &&
		hand[3] == hand[2] + 1 &&
		hand[4] == hand[3] + 1)) {
		
		if (hand[1] == hand[0] + 1 || (hand[0] == 0 && hand[1] == 2)) {
			return STRAIGHT_MASK + hand[4];
		} else if (hand[0] == 0 && hand[4] == 13) {
			return STRAIGHT_MASK + ACE_VAL;
		}
	}
	return 0;
}

int poker(int hand[5]) {
	if (same(hand, 0, 3)) {
		return POKER_MASK + hand[0] << FIRST_CARD_SHIFT + hand[4];
	}
	if (same(hand, 1, 4)) {
		return POKER_MASK + hand[4] << FIRST_CARD_SHIFT + hand[0];
	}
	return 0;
}

int fullhouse(int hand[5]) {
	if (same(hand, 0, 2) && same(hand, 3, 4)) {
		return FULLHOUSE_MASK + hand[0] << FIRST_CARD_SHIFT + hand[4];
	}
	if (same(hand, 0, 1) && same(hand, 2, 4)) {
		return FULLHOUSE_MASK + hand[4] << FIRST_CARD_SHIFT + hand[0];
	}
	return 0;
}

int three(int hand[5]) {
	if (same(hand, 0, 2) || same(hand, 1, 3)) {
		return THREE_MASK + hand[2] << FIRST_CARD_SHIFT + hand[4];
	}
	if (same(hand, 2, 4)) {
		return THREE_MASK + hand[2] << FIRST_CARD_SHIFT + hand[1];
	}
	return 0;
}

int pair(int hand[5]) {
	if (hand[4] == hand[3]) {
		return PAIR_MASK + hand[4] << FIRST_CARD_SHIFT + hand[2];
	}

	for (int i = 3; i > 0; i--) {
		if (hand[i] == hand[i-1]) {
			return PAIR_MASK + hand[i] << FIRST_CARD_SHIFT + hand[4];
		}
	}
	
	return 0;
}

int twopairs(int hand[5]) {
	if (same(hand, 0, 1) && same(hand, 2, 3)) {
		return TWOPAIR_MASK + max(hand[0], hand[2]) << FIRST_CARD_SHIFT + min(hand[0], hand[2]) << SECOND_CARD_SHIFT + hand[4];
	}
	
	if (same(hand, 0, 1) && same(hand, 3, 4)) {
		return TWOPAIR_MASK + max(hand[0], hand[3]) << FIRST_CARD_SHIFT + min(hand[0], hand[3]) << SECOND_CARD_SHIFT + hand[2];
	}
	
	if (same(hand, 1, 2) && same(hand, 3, 4)) {
		return TWOPAIR_MASK + max(hand[1], hand[3]) << FIRST_CARD_SHIFT + min(hand[1], hand[3]) << SECOND_CARD_SHIFT + hand[0];
	}
	
	return 0;
}

int main(void) {
	int N;
	while (scanf(" %d", &N) == 1) {
		char card, color;
		scanf(" %c%c %c%c %c%c %c%c %c%c"
	}
}

